/*
 *  Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.wso2.carbon.sso.redirector.ui.internal;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.osgi.service.component.ComponentContext;

import javax.servlet.Filter;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Dictionary;
import java.util.Hashtable;

import org.osgi.service.component.annotations.Activate;
import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Deactivate;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;
import org.osgi.service.component.annotations.ReferencePolicy;

@Component(
        name = "org.wso2.carbon.sso.redirector.ui",
        immediate = true)
public class SSORedirectorServiceComponent {

    private static Log log = LogFactory.getLog(SSORedirectorServiceComponent.class);

    @Activate
    protected void activate(ComponentContext ctxt) {
        // register a servlet filter for SSO redirector page
        HttpServlet redirectJSPRedirectorServlet = new HttpServlet() {

            protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException,
                    IOException {

            }
        };
        Filter redirectPageFilter = new RedirectorJSPFilter();
        Dictionary redirectorPageFilterAttrs = new Hashtable(2);
        Dictionary redirectorPageFilterParams = new Hashtable(2);
        redirectorPageFilterParams.put("url-pattern", "/carbon/sso-acs/redirect_ajaxprocessor.jsp");
        redirectorPageFilterParams.put("associated-filter", redirectPageFilter);
        redirectorPageFilterParams.put("servlet-attributes", redirectorPageFilterAttrs);
        ctxt.getBundleContext().registerService(Servlet.class.getName(), redirectJSPRedirectorServlet,
                redirectorPageFilterParams);
        log.debug("Stratos SSO Redirector bundle is activated..");
    }

    @Deactivate
    protected void deactivate(ComponentContext ctxt) {

        log.debug("Stratos SSO Redirector bundle is deactivated..");
    }
}
